VERSION 5.00
Object = "{344E011D-7EF2-4612-9DE8-5354720F9B43}#35.0#0"; "SoundProcessor.ocx"
Begin VB.Form frmDTMFDetect 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "www.ActiveVB.de - DTMF-Tne Analysiern"
   ClientHeight    =   2295
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   4920
   LinkTopic       =   "Form2"
   MaxButton       =   0   'False
   MDIChild        =   -1  'True
   MinButton       =   0   'False
   ScaleHeight     =   2295
   ScaleWidth      =   4920
   Begin VB.TextBox Text1 
      Height          =   330
      Left            =   120
      TabIndex        =   5
      Top             =   1080
      Width           =   4605
   End
   Begin VB.CommandButton cmdPause 
      Caption         =   "Pause"
      Enabled         =   0   'False
      Height          =   375
      Left            =   2505
      TabIndex        =   4
      Top             =   570
      Width           =   1050
   End
   Begin VB.CommandButton cmdInit 
      Caption         =   "Init"
      Height          =   375
      Left            =   120
      TabIndex        =   3
      Top             =   570
      Width           =   1050
   End
   Begin VB.CommandButton cmdStop 
      Caption         =   "Stop"
      Height          =   375
      Left            =   3675
      TabIndex        =   2
      Top             =   570
      Width           =   1050
   End
   Begin VB.CommandButton cmdStart 
      Caption         =   "Start"
      Enabled         =   0   'False
      Height          =   375
      Left            =   1290
      TabIndex        =   1
      Top             =   570
      Width           =   1050
   End
   Begin prjSndProc.SndProc SndProc1 
      Height          =   285
      Left            =   120
      TabIndex        =   0
      Top             =   135
      Width           =   330
      _ExtentX        =   582
      _ExtentY        =   503
      Analysis        =   1
   End
   Begin VB.Label Label1 
      Caption         =   "Label1"
      Height          =   540
      Left            =   120
      TabIndex        =   6
      Top             =   1500
      Width           =   4680
   End
End
Attribute VB_Name = "frmDTMFDetect"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Dim F(1 To 8) As Long
Dim FF(8, 8) As String
Dim spec() As Long
Dim HzpPt As Double
'Option Explicit

Private Type Standard_Wave_Header

    Riff As Long       ' Sollte immer "RIFF" enthalten = 1179011410
    Rl As Long         ' Groesse des folgenden "Chunks"
    Typ As Long        ' Typinformation 4 byte "WAVE" = 1163280727
    Fmt As Long        ' Muss "fmt " enthalten = 544501094
    CSize As Long      ' Chunksize
    Tag As Integer     ' Meist unbenutzt
    nChan As Integer   ' Zahl der Kanle
    SPS As Long        ' Samples pro Sekunde
    BpS As Long        ' Bytes pro Sekunde
    Bla As Integer     ' Blockalign (Byte pro Sample)
    Sl As Integer      ' Samplelnge
    Data As Long       ' Muss "DATA" enthalten = 1096040772
    dl As Long         ' Datenlnge
        
End Type

Dim fno As Long
Dim fName$
Dim Header As Standard_Wave_Header
Dim fPos As Long
Dim ccc As Long
Private Function PrepareHeader(ByRef Header As Standard_Wave_Header, _
                               ByVal nSamples As Long, _
                               ByVal nChannels As Long, _
                               ByVal SamplesPerSecond As Long, _
                               ByVal BitsPerSample)
                               
    Dim DataLength As Long
    Dim Rl As Long         ' Lnge der 'Riff'-Chunks

    DataLength = nSamples * nChannels * BitsPerSample / 8

    Rl = 16 + 4 + 4       ' Lnge des Formatchunks + 4 Byte fr "fmt " + 4
    Rl = Rl + DataLength  ' plus Datenlnge
    Rl = Rl + 4 + 4 + 4   '
    
    Header.Riff = 1179011410 ' Wir bereben ein Long welches
                             ' die gleiche Bytefolge wie "RIFF" hat
    Header.Rl = Rl
    Header.Typ = 1163280727 ' = "WAVE"
    Header.Fmt = 544501094  ' = "fmt "
    Header.CSize = 16       ' Lnge des folgenden Chunks
    Header.Tag = 1
    Header.nChan = nChannels
    Header.SPS = SamplesPerSecond
    Header.Bla = nChannels * BitsPerSample / 8
    Header.BpS = Header.SPS * Header.Bla
    Header.Sl = BitsPerSample
    Header.Data = 1635017060
    Header.dl = DataLength
     
End Function


Sub InitFrequencies()

    Dim MaxIx As Long
    Dim i As Long
    Dim ix As Long
    Dim k As Long
    
    F(1) = 697
    F(2) = 770
    F(3) = 852
    F(4) = 941
    F(5) = 1209
    F(6) = 1336
    F(7) = 1477
    F(8) = 1633
    
    FF(1, 5) = "1"
    FF(1, 6) = "2"
    FF(1, 7) = "3"
    FF(1, 8) = "A"
    
    FF(2, 5) = "4"
    FF(2, 6) = "5"
    FF(2, 7) = "6"
    FF(2, 8) = "B"
    
    FF(3, 5) = "7"
    FF(3, 6) = "8"
    FF(3, 7) = "9"
    FF(3, 8) = "C"
    
    FF(4, 5) = "*"
    FF(4, 6) = "0"
    FF(4, 7) = "#"
    FF(4, 8) = "D"
    
    ReDim spec(SndProc1.SPS / 2)
    HzpPt = SndProc1.SPS / SndProc1.Samples
    MaxIx = (F(8) / HzpPt) + 5
    
    For i = 1 To 8
    
        ix = CLng(F(i) / HzpPt)
        For k = 0 To 0
            spec(ix + k) = i
            Debug.Print ix
        Next k
    
    Next i


End Sub


Private Sub cmdInit_Click()

    With frmDTMF
        SndProc1.SPS = .Beeper1.SPS
        SndProc1.Bips = .Beeper1.Bips
        SndProc1.Channels = 1
        If .Beeper1.Stereo = True Then
            SndProc1.Channels = 2
        End If
    End With
    SndProc1.Samples = 1024
    SndProc1.LoopMethod = 1
    SndProc1.Buffers = 5
    SndProc1.analysis = 3
    SndProc1.Threshold = 15
    Debug.Print SndProc1.SamplingTime & " " & SndProc1.SPS / SndProc1.Samples
    Call InitFrequencies
    SndProc1.MissedCount = 0
    SndProc1.Init
    If SndProc1.DeviceHandle = 0 Then
        Exit Sub
    End If
    'SndProc1.Reset
    cmdInit.Enabled = 0
    cmdStart.Enabled = True
    cmdPause.Enabled = True
    ccc = -1
    
End Sub

Private Sub cmdPause_Click()
     Call SndProc1.Pause
     cmdStart.Enabled = True
End Sub

Private Sub cmdStart_Click()
    Call SndProc1.Start
    cmdStart.Enabled = 0
    fPos = 45
    'ccc = 0
End Sub


Private Sub cmdStop_Click()

    SndProc1.Reset
    cmdInit.Enabled = True
    cmdStart.Enabled = 0
    cmdPause.Enabled = 0

End Sub

Private Sub Form_Load()

    Label1.Caption = "Anleitung: Init und Start drcken, dann im DTMF-Genereator " _
                      & "eine Nummer whlen."
    
'    Me.Show
'    frmDTMF.Show
'    frmDTMF.Move frmDTMFDetect.Left, Me.Top - frmDTMF.Height
    

End Sub


Private Sub Form_Unload(Cancel As Integer)

    Close #fno

End Sub


Private Sub SndProc1_Complete(ByVal BlockIndex As Long, ByVal BufferIndex As Long, ByVal dt As Double)

    Dim Peak As Variant
    Dim Spect() As Single
    
    Dim n As Long
    Static cnt As Long
    Static cc As Long
    Static Code$
    Static LastNum$
    Static lastT As Double
    Dim Num$
    Dim NewNum As Boolean
    Dim MaxNum As Long
    Dim i As Long
    Dim ix As Long
    Dim ix1 As Long
    Dim ix2 As Long
    Dim max1 As Long
    Dim max2 As Long
    'Dim wav As Variant
    Dim Wave() As Integer
    Dim Train As Variant
    MaxNum = 5
    
    'Peak = SndProc1.Peaks
    ret = SndProc1.Spectrum(Spect(), 1)
    ret = SndProc1.WaveData(Wave(), 1)
    
    n = UBound(Spect)
    'n = 10
    HzpPt = SndProc1.SPS / SndProc1.Samples
    'If n > 0 Then
    'Debug.Print "Done   " & Format$(BlockIndex, "000") & " " & BufferIndex & " " & Format$(dt, "0.000000") & " " & Format$(dt - lastT, "0.000000") 'SndProc1.MissedCount
    'Debug.Print Format$(dt - lastT, "0.000000") 'SndProc1.MissedCount
    
    lastT = dt
    'Label2(BufferIndex).Caption = Format$(dt, "0.000000")
    'Debug.Print Format$(dt, "0.000000")
    If SndProc1.MaxAmplitudeL > 2000 And n > 40 Then
    
        'ccc = 0
        
        If cc >= 3 Then
            Code$ = ""
        End If
        
        max1 = 0
        max2 = 0
        
        For i = 10 To 40
            If Spect(i) > max1 Then
                max1 = Spect(i)
                ix1 = spec(i)
                'Debug.Print i & " " & spec(spect(i - 1)) & " " & spec(spect(i)) & " " & spec(spect(i + 1))
            End If
        Next i
''
        For i = 10 To 40
            If Spect(i) > max2 Then
                ix = spec(i)
                If ix <> ix1 Then
                    max2 = Spect(i)
                    ix2 = ix
                End If
            End If
        Next i
'
        If ix2 < ix1 Then
            ix = ix2
            ix2 = ix1
            ix1 = ix
        End If
'
        Num$ = FF(ix1, ix2)
        If Num$ <> "" Then
            If Num$ <> LastNum$ Then
                NewNum = True
            Else
                cnt = cnt + 1
                If cnt >= MaxNum Then
                    NewNum = True
                End If
            End If
            LastNum$ = Num$
            'Debug.Print Num$
        End If

        If NewNum = True Then
            Code$ = Code$ & Num$
            cnt = 0
            NewNum = 0
            Text1.Text = Code$
        End If

        If ix1 > 0 And ix2 > 0 Then
            cc = 0
        End If
    Else
        cc = cc + 1
        LastNum$ = ""
        If cc <= 3 Then
            Debug.Print "---"
        End If
        If cc = 3 Then
            Debug.Print Code$
        End If

    End If
    
'    ccc = ccc + 1
'    If ccc = 20 Then
'        Train = SndProc1.Sequence
'        ccc = 0
'        Text$ = ""
'        Fmt$ = Format$(Train(UBound(Train)))
'        If Len(Fmt$) > 3 Then
'            Fmt$ = String$(Len(Fmt$), "0")
'        Else
'            Fmt$ = String$(3, "0")
'        End If
'        For i = UBound(Train) - 20 To UBound(Train)
'            If Train(i) > 0 Then
'                Text$ = Text$ & Format$(Train(i), Fmt$) & " "
'            Else
'                Text$ = Text$ & String$(Len(Fmt$), "-") & " "
'            End If
'        Next i
'        Debug.Print Text$
'    End If
     
 End Sub


Private Sub SndProc1_MissedBuffer(ByVal BlockIndex As Long, ByVal BufferIndex As Long, ByVal dt As Double)

    'Debug.Print "Missed " & BlockIndex & " " & BufferIndex & " " & Format$(dt, "0.000000")

End Sub


